function [RMSE,MAE,MAPE,MPE,LogDetMSSE,TraceMSSE]=PredAccuracy(PredsFixedHorizon,DataFixedHorizon,EvalHorizons,MSSEScaleMatrix,DieboldMariano)

% If PredsFixedHorizonNaive is empty, do not try to compute accuracy of naive forecasts
NPredVars=size(PredsFixedHorizon,2);
NModels=size(PredsFixedHorizon,4);
NCoverProb=length(CoverProb);
NScalings=size(MSSEScaleMatrix,3);
NEvalHorizons=length(EvalHorizons);
LogDetMSSE=zeros(NEvalHorizons,NScalings,NModels);
TraceMSSE=zeros(NEvalHorizons,NScalings,NModels);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% Accuracy of Naive forecasts %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for k=1:NModels
    PredError(:,:,:,k)=PredsFixedHorizon(:,:,:,k)-DataFixedHorizon;
end
MPE=zeros(NEvalHorizons,NPredVars,NModels);
RMSE=zeros(NEvalHorizons,NPredVars,NModels);
MAE=zeros(NEvalHorizons,NPredVars,NModels);
MAPE=zeros(NEvalHorizons,NPredVars,NModels);
for k=1:NModels
    for j=1:NEvalHorizons
        AvailableDataObs=1:max(find(PredsFixedHorizon(:,1,j,k)));
        if length(AvailableDataObs)>1
            MPE(j,:,k)=100*mean(PredError(AvailableDataObs,:,j,k)./DataFixedHorizon(AvailableDataObs,:,j));
            RMSE(j,:,k)=sqrt(mean(PredError(AvailableDataObs,:,j,k).^2));
            MAE(j,:,k)=mean(abs(PredError(AvailableDataObs,:,j,k)));    
            MAPE(j,:,k)=100*mean(abs(PredError(AvailableDataObs,:,j,k)./DataFixedHorizon(AvailableDataObs,:,j)));
        else
            MPEN(j,:,k)=100*PredError(AvailableDataObs,:,j,k)./DataFixedHorizon(AvailableDataObs,:,j);
            RMSE(j,:,k)=sqrt(PredError(AvailableDataObs,:,j,k).^2);
            MAE(j,:,k)=abs(PredError(AvailableDataObs,:,j,k));
            MAPE(j,:,k)=100*abs(PredError(AvailableDataObs,:,j,k)./DataFixedHorizon(AvailableDataObs,:,j));
        end
        for u=1:NScalings
            MSSE(:,:,j,k,u)=(1/(length(AvailableDataObs)))*(PredError(AvailableDataObs,:,j,k)*MSSEScaleMatrix(:,:,u))'...
                *(PredError(AvailableDataObs,:,j,k)*MSSEScaleMatrix(:,:,u));
            LogDetMSSE(j,u,k)=log(det(MSSE(:,:,j,k,u)));
            TraceMSSE(j,u,k)=trace(MSSE(:,:,j,k,u));
        end
    end
end